**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom              Primal2
Sequence         1 - Initiation  la programmation mathmatique avec GAMS
Type             LP
Langage GAMS     Valeur nulle dans une matrice, crire une variable indifrement du ct droit ou gauche d'une contrainte
Description
Desserrer la contrainte de travail
" Soit une exploitation agricole qui peut pratiquer deux cultures : le bl et le mas.
On cherche  dterminer la superficie  cultiver dans chaque production, sachant que :
L'objectif de l'agriculteur est la maximisation du revenu
Par hectare, le rendement du bl est de 5 tonnes et celui du mais de 10 tonnes.
Respectivement, ils ont des couts de production de 300/ha et 500/ha.
Les deux crales sont vendues 150/tonnes.
Le bl utilise 25 heures de travail par ha et par an et le mais 50 heures
La surface de l'exploitation est de 50 ha et l'agriculteur dispose de 2000 heures de travail par an.
L'agriculteur a la possibilit d'embaucher des travailleurs salaris  15/h."


$Offtext
*-----------------------------------------------------------------------------*



*~~~~~~~~~~~~~~~~~~~~~~~~ INDICES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
sets
C cultures  /ble,mais/
;

*~~~~~~~~~~~~~~~~~~~~~~~~ DONNEES ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
scalar
DTERRE disponibilite de terre en hectares          /50/
DMO    disponibilite de travail en heures        /2000/
PMO    prix horaire de la main d'oeuvre salarie   /15/
;

parameter
BMO(C) besoins en travail par hectare et par culture (heures)
/ble    25
 mais   50/

MB(C) marge brute par culture (euros)
/ble    450
 mais  1000/
;

*~~~~~~~~~~~~~~~~~~~~~~~~ MODELE  ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
variables
   Z    revenu total de l exploitation (euros)
;

positive variables
   X superficie par culture (hectares)
   MOS nombre d'heures salaries (heures)
;

equations
   OBJECTIF       fonction objectif
   TERRE          contrainte de terre
   TRAVAIL        contrainte de travail
;

OBJECTIF..  sum(c, mb(c)*X(c)) - PMO*MOS =E= Z ;

TERRE..    sum(c, X(c)) =l= dterre ;

TRAVAIL..  sum(c, bmo(c)*X(c)) =L= dmo + MOS ;


model exemple premier exemple /all/;

*~~~~~~~~~~~~~~~~~~~~~~~~ SOLUTION ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*
solve exemple using LP maximizing Z;



parameter RESULT(*,*);
RESULT('TERRE','TOTAL') = TERRE.L;
RESULT('TERRE','MARGINAL') = TERRE.M;
RESULT('TRAVAIL','TOTAL') = TRAVAIL.L;
RESULT('TRAVAIL','MARGINAL') = TRAVAIL.M;
display result;